/**
 * Created by godsong on 14-7-21.
 */
/**
 * Created by godsong on 14-7-11.
 */
var through2 = require('through2');
var uglify = require('gulp-uglify');
var minifyCss = require('gulp-minify-css');
var crypto = require('crypto');
var Path=require('path');
var gutil=require('gulp-util');
var fs = require('fs');
var rg_script = /<script[^>]*src=(['"])(.*?)\1[^>]*>[^<]*<\/script>|<link[^>]*href=(['"])(.*?\.css)\1[^>]*\/?>/gi;
module.exports = function (config) {
    config=config||{};
    config.base=config.base||'./';
    var processer = function (htmlFile, encoding, callback) {

        var html=String(htmlFile.contents);
        var jsList=[],cssList=[];
        var output=html.replace(rg_script,function(m,a,src,b,href){
            if(src){
                jsList.push(src);
            }
            if(href){
                cssList.push(href);
            }
            return "";
        });
        var cwd=Path.resolve(config.base),ext=Path.extname(htmlFile.path),htmlName=Path.basename(htmlFile.path,ext);
        htmlFile.base=cwd;
        htmlFile.path=Path.join('./themes/public/views/resource.release/',htmlName+ext);
        console.log('resolve:'+htmlName);
        var jsResult=resolveScripts.call(this,jsList,htmlName,config);
        var cssResult=resolveCss.call(this,cssList,htmlName,config);
        if(jsResult.modified||cssResult.modified) {
            output += '<script type="text/javascript" src="/' + Path.relative(cwd, jsResult.path) + '"></script>\n';
            output += '<link rel="stylesheet" href="/' + Path.relative(cwd, cssResult.path) + '" />';
            htmlFile.contents = new Buffer(output.trim());
            this.push(htmlFile);
        }
        else {
            console.log('abort build ',htmlName);
        }
        //this.push(jsFile);
        console.log('==============================');
        callback();
    };
    return through2.obj(processer);
};

module.exports.clean=function(dirs){
    dirs.forEach(function(path){
        var fileGroup={};
        fs.readdir(path,function(err,files){
            if(err){
                console.log(err);
            }
            if(files){
                files.forEach(function(filename){
                    var stat=fs.statSync(Path.join(path,filename));
                    var match=filename.match(/^.*?\.res_/);
                    if(match){
                        var fg=fileGroup[match[0]];
                        if(!fg){
                            fileGroup[match[0]]=[{name:Path.join(path,filename),mtime:stat.mtime}];
                        }
                        else{
                            fg.push({name:Path.join(path,filename),mtime:stat.mtime})
                        }
                    }
                });

                for(var k in fileGroup){
                    if(fileGroup.hasOwnProperty(k)) {
                        fileGroup[k].sort(function(a, b) {
                            if(a.mtime > b.mtime) {
                                return -1;
                            }
                            else if(a.mtime == b.mtime) {
                                return 0;
                            }
                            else return 1;
                        });
                        fileGroup[k].forEach(function(e, i) {
                            if(i > 1) {//留两个
                                console.log('clean:', e.name);
                                fs.unlink(e.name, function(err) {
                                    if(err) {
                                        console.log(err)
                                    }
                                });
                            }
                        });
                    }
                }
            }
        })
    })
};
function resolveScripts(jsList,htmlName,config){
    var uglifyThrough=uglify(/*{mangle:{toplevel:true}}*/);
    var self=this;
    var jsBuffer='';

    for(var i=0;i<jsList.length;i++){
        var jsfileName=jsList[i].replace(/^\//,'');
        jsBuffer+='\n/******'+jsfileName+'*******/\n';
        jsBuffer+=fs.readFileSync(Path.resolve(config.base,jsfileName)).toString();
    }
    var shasum = crypto.createHash('md5');
    shasum.update(jsBuffer);
    var jsPath=Path.join(config.base,'/themes/public/javascript.release/',htmlName+'_'+shasum.digest("hex")+'.js');
    var jsFile=new gutil.File({
        path:jsPath,
        contents:new Buffer(jsBuffer)
    });
    if(!fs.existsSync(jsPath)) {
        uglifyThrough.on('data', function (file) {
            self.push(file);
        });
        uglifyThrough.write(jsFile);
        console.log('======>' + Path.basename(jsPath).slice(0,-27)+'.css');
        return {path:jsFile.path,modified:true};
    }
    else {
        console.log('there is no js modified!');
        return {path:jsFile.path,modified:false};
    }
}

function resolveCss(cssList,htmlName,config){
    var self=this;
    var cssBuffer='';
    for(var i=0;i<cssList.length;i++){
        var cssFileName=cssList[i].replace(/^\//,'');
        cssBuffer+='\n/******'+cssFileName+'*******/\n';
        var cssContent=fs.readFileSync(Path.resolve(config.base,cssFileName));
        console.log(cssList[i]);
        if(Path.dirname(cssFileName)!=='themes/public/stylesheets') {
            cssContent= cssContent.toString().replace(/url\( *(['"]?)(\.\.\/[^\1\)]+)\1 *\)/g, function(m, a, b) {
                return 'url('+a +
                       Path.relative('./themes/public/stylesheets', Path.join('./', Path.dirname(cssList[i]), b)) +
                       a+')';
            });
        }
        cssBuffer +=cssContent;

    }
    var shasum = crypto.createHash('md5');
    shasum.update(cssBuffer);
    var cssPath=Path.join(config.base,'/themes/public/stylesheets.release/',htmlName+'_'+shasum.digest("hex")+'.css');
    var cssFile=new gutil.File({
        path:cssPath,
        contents:new Buffer(cssBuffer)
    });

    //cssThrough.write(cssFile);
    if(!fs.existsSync(cssPath)) {
        this.push(cssFile);
        console.log('======>' + Path.basename(cssPath).slice(0,-27)+'.css');
        return {path:cssFile.path,modified:true};
    }
    else{
        console.log('there is no css modified!');
        return {path:cssFile.path,modified:false};
    }
}
